// 
//
#include <stdio.h>
#include <stdlib.h>

#include "File.h"

#include <sys/stat.h>
#include <string.h>
#include <strstream.h>
#include <fstream.h>

#ifdef HAVE_STL
#include <vector.h>
#include <deque.h>
#else
#include "List.h"
#include "Queue.h"
#endif

#include "Password.h"
#include "Server.h"

extern int maxdepth;

#ifdef HAVE_STL
static vector<File *> seen;
static deque<URL *> curr;
#else
static List<File> seen;
static Queue<URL> curr;
#endif

//extern "C" {
	char* strstr_no_care(char *s1, char *s2);
//}


File::File( URL *u ) : url(u), theType( UNKNOWN )
{
   if ( strstr(url->Full(), "mailto") ) theType = MAIL;
   if ( url->File()[0] == '#' ) theType = REF;
}

File::File( File *f ) : url( new URL( f->url )), theType( f->theType )
{
   ;
}

File::~File()
{
   delete url;
}

void File::Retrieve( int depth, char *save, Password *passwd )
{
#ifdef HAVE_STL
    vector<File *> todo;     
#else
    Queue<File> todo;     
#endif

    if ( theType == MAIL || theType == REF ) return;

    Server server( url->Host(), url->Port() );
    strstream command;
    strstream dirname;
    dirname << save;

    for ( int i=maxdepth; i > depth; i-- ) cout << "  ";
    if ( url->Relative() ) {
       printf("RELATIVE: http://%s",url->Host());
       if ( url->Port() != 80 ) printf(":%i",url->Port());
#ifdef HAVE_STL
       printf("%s",curr.front()->Dir());
       dirname << curr.front()->Dir();
#else
//       cout << curr.Top()->Dir();
//       dirname << curr.Top()->Dir();
#endif
	printf("%s%s\n",url->Dir(),url->File());
    } else {
       printf("ABSOLUTE: http://%s",url->Host());
       if ( url->Port() != 80 ) printf(":%i",url->Port());
#ifdef HAVE_STL
       curr.push_back( new URL( url ) );
#else
       curr.Push( new URL( url ) );
#endif
	   printf("%s\n",url->Path());
    }
//    cout << url->Path() << endl;
    dirname << url->Dir() << '\0';
    
    {
       char full[256];
       char name[256];
       strcpy( full, dirname.str() );
       int l = strlen(full);
       if ( l && full[l-1] == '/' ) full[l-1] = 0;

	int count = 0;
       name[0] = 0;
       char *dir = strtok(full,"/");
       while ( dir ) {
          struct stat t;
          if(count!=0 || full[0]=='/') strcat(name, "/");
          strcat(name,dir);
          int status = stat( name, &t );
cout << name << endl;
          if ( status ) {           
             status = mkdir( name, S_IREAD|S_IWRITE|S_IEXEC );
// debug .......
//             if ( status && errno != EEXIST ) {
//                cout << "Unable to create directory '" << name << "'" << endl;
//                return;
//             }
// .......  debug
          }
          dir = strtok(0,"/");
		count++;
       }
    }
   
//    if ( url->Relative() ) {
//       cout << curr.front()->Dir();
//       cout << url->Path() << endl;
//    } else cout << url->Path() << endl;

    command << "GET ";
    if ( url->Relative() ) {
#ifdef HAVE_STL
       command << curr.front()->Dir();
#else
//       command << curr.Top()->Dir();
#endif
//       command << url->Path() << " HTTP/1.0\r\n";
       command << url->Dir() << url->File() << " HTTP/1.0\r\n";
    } else command << url->Path() << " HTTP/1.0\r\n";
    command << "User-Agent: web_mirror/1.0" << "\r\n";
    if (passwd) command << "Authorization: Basic " << *passwd << "\r\n";
    command << "Accept: */*" << "\r\n";
    command << "\r\n" << '\0';

    server.Write(command.str());

    //
    // UPGRADE: Setup a timeout for the connection
    //
    char line[8192*8];
    while ( server.ReadLine(line, 8192*8, "\n") ) {
       int len = strlen(line);
       if ( len && line[len-1] == '\r' ) line[--len] = 0;
       if ( len == 0 ) break;
#ifdef DEBUG
cout << "***>" << line << "<***" << endl;          
#endif
       if ( strstr(line,"Not Found")) {
          cout << "'" << url->Full() << "' not found." << endl;
          theType = File::BAD;
          break;
       } else if ( strstr(line,"HTTP") == line ) {
          int status;
       } else if ( strstr(line,"Content-type:") || strstr(line,"Content-Type:")) {
          if ( strstr( line, "html" )) theType = File::HTML;
          if ( strstr( line, "image" )) theType = File::GIF;
       }  
    }

    ofstream *out = 0;
    strstream filename;
    filename << dirname.str() << url->File() << '\0';

    switch ( theType ) {

    case File::HTML :
       out = new ofstream( filename.str() );
       if (!*out) {
          cout << "Unable to create '" << filename.str() << "'" << endl; 
          return;
       }

       while ( server.ReadLine(line, 8192*8, "\n") ) {
          char *start = line;
          char *next = line;

// This is for changing absolute address to relative address.
//    char string[8192*8];
	char *cur_path;
	char *s , *t , *p ;
	s = strdup(line);
	t = p = s;
	
	for (;;)
		if ( ( t = strstr_no_care(p,"<a href"))  ||
			( t = strstr_no_care(p,"<img src"))) {
		t = strchr(t, '\"');
		if (t)
		if (*(t+1) == '/') {
			*(t+1) = '\0';
			if(*save == '/') *out << s << save << "/";
			else {
				cur_path = getcwd(NULL, 80);
				*out << s << cur_path << "/" << save << "/";
				free(cur_path);
			}
			s = t+2;
			t = p = s;
		}
		else p = t;
		else break;
	}
	else break;
	*out << s << endl << flush;
	
//          *out << line << endl << flush;      
// End of changing.

          while (next) {
             next = strstr(start,"</a>");
             if ( URL::HasURL(start) ) {
                File *file = new File(new URL(start, url->xDir()));
//                File *file = new File(new URL(start));
                int alreadySeen=0;
#ifdef HAVE_STL
                for ( vector<File *>::iterator i = seen.begin(); i < seen.end(); i++ ) {
                   if ( !strcmp((*i)->TheURL()->Path(), file->TheURL()->Path())) {
#else
                for ( Object<File> *i = seen.Head(); i; i = i->Next() ) {
                   if ( !strcmp( i->Item()->TheURL()->Path(), file->TheURL()->Path())) {
#endif
                      alreadySeen=1;
                      break;
   	           }
	        }
                if (!alreadySeen) {
#ifdef HAVE_STL
                   seen.push_back( new File( file ));
                   todo.push_back( file );
#else
                   seen.Add( new File( file ));
                   todo.Push( file );
#endif
	        } else delete file;
             }
             start = next+strlen("</a>");
          }
       }
       break;

    case File::GIF :
    case File::JPEG :
       int count;
       out = new ofstream( filename.str() );
       if (!out) return;
       while ( (count = server.Read(line, 1024 )) ) {
          out->write( line, count );
       }
       break;

    default:
       break;
    }

    if (out) delete out;
    server.Close();

#ifdef HAVE_STL
    for ( vector<File *>::iterator i = todo.begin(); i < todo.end(); i++ ) {
      if ( depth ) {
          if ( Server::IsCurrent( (*i)->TheURL()->Host(),
                                  (*i)->TheURL()->Port() ) ) {
             (*i)->Retrieve( depth-1, save, passwd );
	  } 
       }
       delete (*i);
#else
    File *j;
    while ( (j = todo.Pop()) != 0 ) {
//      if ( depth && !strstr(j->TheURL()->Path(), "stats")) {
      if ( depth ) {
          if ( Server::IsCurrent( j->TheURL()->Host(),
                                  j->TheURL()->Port() ) ) {
             j->Retrieve( depth-1, save, passwd );
	  } 
       }
       delete j;
#endif
    }

#ifdef HAVE_STL
   if ( !url->Relative() ) curr.pop_front();
#else
   if ( !url->Relative() ) { URL *u = curr.Pop(); if (u) delete u; }
#endif
}


